"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/index.ts
var src_exports = {};
__export(src_exports, {
  CreatePlugin: () => CreatePlugin
});
module.exports = __toCommonJS(src_exports);

// src/CreatePlugin.ts
var import_copy_anything = require("copy-anything");
var import_filter_anything = require("filter-anything");
var import_is_what6 = require("is-what");
var import_getorset_anything = require("getorset-anything");
var import_utils2 = require("@magnetarjs/utils");

// src/actions/mergeAssignReplace.ts
var import_merge_anything = require("merge-anything");
function writeActionFactory(data, vue2StoreOptions, actionName, makeBackup) {
  const { vueInstance: vue } = vue2StoreOptions;
  return function({
    payload,
    collectionPath,
    docId,
    pluginModuleConfig
  }) {
    if (!docId)
      throw new Error("An non-existent action was triggered on a collection");
    const collectionDic = data[collectionPath];
    if (makeBackup)
      makeBackup(collectionPath, docId);
    if (actionName === "replace" || !collectionDic[docId]) {
      vue.set(collectionDic, docId, {});
    }
    const docDataToMutate = collectionDic[docId];
    if (!docDataToMutate)
      throw new Error(`Document data not found for id: ${collectionPath} ${docId}`);
    if (actionName === "merge") {
      Object.entries(payload).forEach(([key, value]) => {
        vue.set(docDataToMutate, key, (0, import_merge_anything.merge)(docDataToMutate[key], value));
      });
    }
    if (actionName === "assign" || actionName === "replace") {
      Object.entries(payload).forEach(([key, value]) => {
        vue.set(docDataToMutate, key, value);
      });
    }
  };
}

// src/actions/insert.ts
var import_is_what = require("is-what");
function insertActionFactory(data, vue2StoreOptions, makeBackup) {
  const { generateRandomId, vueInstance: vue } = vue2StoreOptions;
  return function({
    payload,
    collectionPath,
    docId,
    pluginModuleConfig
  }) {
    const collectionDic = data[collectionPath];
    const _docId = docId || ((0, import_is_what.isFullString)(payload.id) || (0, import_is_what.isNumber)(payload.id) ? String(payload.id) : generateRandomId());
    if (makeBackup)
      makeBackup(collectionPath, _docId);
    const docDataToMutate = collectionDic[_docId];
    if (!docDataToMutate) {
      vue.set(collectionDic, _docId, payload);
      return _docId;
    }
    Object.entries(payload).forEach(([key, value]) => {
      vue.set(docDataToMutate, key, value);
    });
    return _docId;
  };
}

// src/actions/deleteProp.ts
var import_is_what2 = require("is-what");
var import_path_to_prop = require("path-to-prop");
function deletePropActionFactory(data, vue2StoreOptions, makeBackup) {
  return function({
    payload,
    collectionPath,
    docId,
    pluginModuleConfig
  }) {
    const { vueInstance: vue } = vue2StoreOptions;
    if (!docId)
      throw new Error("An non-existent action was triggered on a collection");
    const collectionDic = data[collectionPath];
    const docData = collectionDic[docId];
    if (!docData)
      throw new Error(`Document data not found for id: ${collectionPath} ${docId}`);
    if (makeBackup)
      makeBackup(collectionPath, docId);
    const payloadArray = (0, import_is_what2.isArray)(payload) ? payload : [payload];
    for (const propToDelete of payloadArray) {
      const isNestedPropPath = /[./]/.test(propToDelete);
      if (isNestedPropPath) {
        const parts = propToDelete.split(/[./]/);
        const lastPart = parts.pop();
        const parentRef = (0, import_path_to_prop.getProp)(docData, parts.join("."));
        vue.delete(parentRef, lastPart || "");
      } else {
        vue.delete(docData, propToDelete);
      }
    }
  };
}

// src/actions/delete.ts
var import_is_what3 = require("is-what");
function deleteActionFactory(data, vue2StoreOptions, makeBackup) {
  return function({
    payload,
    collectionPath,
    docId,
    pluginModuleConfig
  }) {
    const { vueInstance: vue } = vue2StoreOptions;
    const _docId = docId || payload;
    if (!(0, import_is_what3.isFullString)(_docId))
      throw new Error("No ID passed to delete action.");
    if (makeBackup)
      makeBackup(collectionPath, _docId);
    vue.delete(data[collectionPath], _docId);
  };
}

// src/actions/fetch.ts
var import_is_what4 = require("is-what");
var import_utils = require("@magnetarjs/utils");
function fetchActionFactory(data, vue2StoreOptions) {
  return function({
    payload,
    collectionPath,
    docId,
    actionConfig,
    pluginModuleConfig
  }) {
    const force = (payload == null ? void 0 : payload.force) === true;
    const optimisticFetch = !force;
    if (optimisticFetch) {
      if (!docId) {
        const { where, orderBy, limit } = pluginModuleConfig;
        const collectionData = (0, import_utils.filterDataPerClauses)(new Map(Object.entries(data[collectionPath])), {
          where,
          orderBy,
          limit
        });
        if (Object.keys(collectionData).length > 0) {
          const localDocs = Object.entries(collectionData).map(([_docId, data2]) => ({
            data: data2,
            exists: "unknown",
            id: _docId
          }));
          const fetchResponse = { docs: localDocs };
          return fetchResponse;
        }
      }
      if (docId) {
        const localDoc = data[collectionPath][docId];
        if (localDoc) {
          const fetchResponse = {
            docs: [
              {
                data: localDoc,
                exists: "unknown",
                id: docId
              }
            ]
          };
          return fetchResponse;
        }
        if (!localDoc) {
        }
      }
    }
    const doOnFetchAction = (_payload, meta) => {
      if (_payload === void 0)
        return;
      insertActionFactory(
        data,
        vue2StoreOptions
      )({
        payload: _payload,
        collectionPath,
        docId: docId || ((0, import_is_what4.isFullString)(meta.id) || (0, import_is_what4.isNumber)(meta.id) ? `${meta.id}` : void 0),
        actionConfig,
        pluginModuleConfig
      });
    };
    return doOnFetchAction;
  };
}

// src/actions/stream.ts
var import_is_what5 = require("is-what");
function streamActionFactory(data, vue2StoreOptions) {
  return function({
    payload,
    collectionPath,
    docId,
    actionConfig,
    pluginModuleConfig,
    mustExecuteOnRead
  }) {
    const doOnStream = {
      added: (payload2, meta) => {
        if (payload2 === void 0)
          return;
        const _docId = docId || `${meta.id}`;
        insertActionFactory(
          data,
          vue2StoreOptions
        )({
          payload: payload2,
          collectionPath,
          docId: _docId,
          actionConfig,
          pluginModuleConfig
        });
      },
      modified: (payload2, meta) => {
        if (payload2 === void 0)
          return;
        const _docId = docId || `${meta.id}`;
        insertActionFactory(
          data,
          vue2StoreOptions
        )({
          payload: payload2,
          collectionPath,
          docId: _docId,
          actionConfig,
          pluginModuleConfig
        });
      },
      removed: (payload2, meta) => {
        if (payload2 === void 0)
          return;
        const collectionPathDocIdToDelete = (0, import_is_what5.isFullString)(docId) ? [collectionPath, docId] : (0, import_is_what5.isString)(payload2) ? [collectionPath, payload2] : [collectionPath, meta.id];
        const [_cPath, _dId] = collectionPathDocIdToDelete;
        deleteActionFactory(
          data,
          vue2StoreOptions
        )({
          payload: void 0,
          collectionPath: _cPath,
          docId: _dId,
          actionConfig,
          pluginModuleConfig
        });
      }
    };
    return doOnStream;
  };
}

// src/actions/revert.ts
function revertActionFactory(data, vue2StoreOptions, restoreBackup) {
  return function({
    payload,
    collectionPath,
    docId,
    pluginModuleConfig,
    actionName,
    error
  }) {
    if (actionName === "stream" || actionName === "fetch") {
      return;
    }
    if (docId && ["insert", "merge", "assign", "replace", "delete", "deleteProp"].includes(actionName)) {
      restoreBackup(collectionPath, docId);
      return;
    }
    if (!docId && actionName === "insert")
      actionName = "insert on collections";
    console.error(`[@magnetarjs/plugin-vue2] revert not yet implemented for ${actionName}`);
  };
}

// src/helpers/dataHelpers.ts
function objectToMap(object, originalObjectToClear, entriesInCustomOrder) {
  const dic = object || {};
  function get(id) {
    return dic[id];
  }
  function has(id) {
    return !!dic[id];
  }
  function keys() {
    if (entriesInCustomOrder)
      return entriesInCustomOrder.map((e) => e[0]);
    return Object.keys(dic);
  }
  function values() {
    if (entriesInCustomOrder)
      return entriesInCustomOrder.map((e) => e[1]);
    return Object.values(dic);
  }
  function entries() {
    if (entriesInCustomOrder)
      return entriesInCustomOrder;
    return Object.entries(dic);
  }
  function clear() {
    if (!originalObjectToClear)
      return;
    if (entriesInCustomOrder) {
      entriesInCustomOrder.forEach(([key]) => {
        delete originalObjectToClear[key];
      });
    } else {
      Object.keys(originalObjectToClear).forEach((key) => {
        delete originalObjectToClear[key];
      });
    }
  }
  function _delete(id) {
    const existed = id in dic;
    if (existed)
      delete dic[id];
    return existed;
  }
  function forEach(callbackfn) {
    const _entries = entriesInCustomOrder || Object.entries(dic);
    _entries.forEach(([k, v]) => {
      callbackfn(v, k, /* @__PURE__ */ new Map());
    });
  }
  const raw = dic;
  const customMap = {
    size: Object.keys(dic).length,
    get,
    has,
    keys,
    values,
    entries,
    forEach,
    clear,
    delete: _delete,
    raw
  };
  return customMap;
}

// src/CreatePlugin.ts
var CreatePlugin = (vue2StoreOptions) => {
  const { vueInstance: vue } = vue2StoreOptions;
  const data = vue.observable({});
  const dataBackups = {};
  const makeBackup = (collectionPath, docId) => {
    if (!(collectionPath in dataBackups))
      dataBackups[collectionPath] = /* @__PURE__ */ new Map();
    const backupCollectionMap = dataBackups[collectionPath];
    const arr = (0, import_getorset_anything.mapGetOrSet)(backupCollectionMap, docId, () => []);
    const foundDoc = data[collectionPath][docId];
    if (foundDoc)
      arr.push((0, import_copy_anything.copy)(foundDoc));
  };
  const restoreBackup = (collectionPath, docId) => {
    if (!(collectionPath in dataBackups))
      return;
    const backupCollectionMap = dataBackups[collectionPath];
    if (!backupCollectionMap.has(docId))
      return;
    const docBackupArray = backupCollectionMap.get(docId);
    if (!docBackupArray || !docBackupArray.length) {
      vue.delete(data[collectionPath], docId);
      return;
    }
    const docBackup = docBackupArray.pop();
    if (docBackup)
      vue.set(data[collectionPath], docId, docBackup);
    if (docBackup === void 0)
      vue.delete(data[collectionPath], docId);
  };
  const modulesAlreadySetup = /* @__PURE__ */ new Set();
  const setupModule = ({
    collectionPath,
    docId,
    pluginModuleConfig = {}
  }) => {
    const modulePath = [collectionPath, docId].filter(Boolean).join("/");
    if (modulesAlreadySetup.has(modulePath))
      return;
    if (!(collectionPath in data))
      vue.set(data, collectionPath, {});
    const dataCollectionDic = data[collectionPath];
    modulesAlreadySetup.add(modulePath);
    const { initialData } = pluginModuleConfig;
    if (!initialData)
      return;
    if (!docId && (0, import_is_what6.isArray)(initialData)) {
      if (Object.keys(dataCollectionDic).length > 0)
        return;
      for (const [_docId, _docData] of initialData) {
        vue.set(dataCollectionDic, _docId, _docData);
      }
    } else if (docId && (0, import_is_what6.isPlainObject)(initialData)) {
      if (docId in dataCollectionDic)
        return;
      vue.set(dataCollectionDic, docId, initialData);
    }
  };
  const getModuleData = ({
    collectionPath,
    docId,
    pluginModuleConfig = {}
  }) => {
    const dataCollectionDic = data[collectionPath];
    if (docId)
      return dataCollectionDic[docId];
    const clauses = (0, import_filter_anything.pick)(pluginModuleConfig, ["where", "orderBy", "limit", "startAfter"]);
    const result = (0, import_utils2.filterDataPerClauses)(new Map(Object.entries(dataCollectionDic)), clauses);
    const resultEntries = [...result.entries()];
    const resultAsDic = Object.fromEntries(resultEntries);
    return objectToMap(resultAsDic, dataCollectionDic, resultEntries);
  };
  const fetch = fetchActionFactory(data, vue2StoreOptions);
  const stream = streamActionFactory(data, vue2StoreOptions);
  const insert = insertActionFactory(data, vue2StoreOptions, makeBackup);
  const _merge = writeActionFactory(data, vue2StoreOptions, "merge", makeBackup);
  const assign = writeActionFactory(data, vue2StoreOptions, "assign", makeBackup);
  const replace = writeActionFactory(data, vue2StoreOptions, "replace", makeBackup);
  const deleteProp = deletePropActionFactory(data, vue2StoreOptions, makeBackup);
  const _delete = deleteActionFactory(data, vue2StoreOptions, makeBackup);
  const revert = revertActionFactory(data, vue2StoreOptions, restoreBackup);
  const instance = {
    revert,
    actions: {
      fetch,
      stream,
      insert,
      merge: _merge,
      assign,
      replace,
      deleteProp,
      delete: _delete
    },
    setupModule,
    getModuleData
  };
  return instance;
};
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  CreatePlugin
});
